import std.conv;
import std.stream;
import std.string;

import log;

// for atof

class Rc {
public:
	this() {
	}

	void addDefault() {
	}
	void addResourceFile() {
		addResourceFile("data/cave.rc");
		addResourceFile("save/cave.rc");
	}
	void addResourceFile(char[] file) {
		auto File input;
		try {
			input = new File(file);
		}
		catch (Error e) {
			Log.error(e.toString());
		}

		if (input.eof()) {
			Log.error(file ~ ": file not found");
		}

		while (!input.eof()) {
			char[] line = input.readLine();
			if (line.length == 0 || line[0] == '#') continue;
			char[][] tok = split(line);
			if (tok.length < 2) {
				Log.warn(file ~  ": resource file broken. (" ~ line ~ ")");
			}

			int valIndex = (tok[1] == "=") ? 2 : 1;

			set(tok[0], join(tok[valIndex..tok.length], " "));
		}
	}
	void addArgument(char args[][]) {
	}

    void save() {
        auto File o = new File("save/cave.rc", FileMode.OutNew);
        foreach (char[] k, char[] v; rc_) {
            o.writeLine(k ~ ` ` ~ v);
        }
    }

public:
	bit hasKey(char[] key) {
		return !!rc_[key];
	}

	char[] get(char[] key) {
		if (!rc_[key]) {
			Log.warn(key ~ " is not in resource");
			return "";
		}
		return rc_[key];
	}
	int getInt(char[] key) {
		return toInt(get(key));
	}
	float getFloat(char[] key) {
		return atof(get(key));
	}

	void set(char[] key, char[] val) {
		rc_[key] = val;
	}

	char[][] keys() {
		return rc_.keys;
	}

private:
	char[][char[]] rc_;

};

unittest {
	void doAssert(bit b) {
		if (!b) {
			stdout.writeLine("assert failure");
		}
	}

	auto Rc rc = new Rc();
	Rc.obj().set("hoge", "huga");
	doAssert("huga" == Rc.obj().get("hoge"));
	doAssert(null == Rc.obj().get("huga"));
}

